]> git.cworth.org Git - empires-server/blob - test
Implement glyph detection on the server side
[empires-server] / test
1 #!/bin/bash
2
3 # Arrange for some cleanup to be executed if the user interrupts the
4 # test sutie (for example, by pressing ControlC at the controlling
5 # terminal).
6 cleanup_and_report() {
7     empathy_deactivate_all >/dev/null 2>&1
8     TEST_REPORT
9     exit $?
10 }
11 trap cleanup_and_report INT
12
13 usage ()
14 {
15     echo "Usage:$0 <URL-to-test>"
16 }
17
18 if [ $# -lt 1 ]; then
19     echo "Error: No test URL given." >&2
20     echo "" >&2
21     usage >&2
22     exit 1
23 fi
24
25 URL=$1
26 CURL="curl --silent --show-error"
27
28 _TEST_SECTION()
29 {
30     echo ""
31     echo $1
32     echo $1 | sed -e "s/./$2/g"
33 }
34
35 TEST_SECTION()
36 {
37     _TEST_SECTION "$1" =
38 }
39
40 TEST_SUBSECTION()
41 {
42     _TEST_SECTION "$1" -
43 }
44
45 TEST()
46 {
47     printf "    $1"
48     printf "%*s" $(( 52 - ${#1} )) | tr ' ' '.'
49     (( tests_total++ )) || true
50 }
51
52 # Result of test depends on the exit status of last command
53 TEST_END()
54 {
55     if [ $? -eq 0 ]; then
56         echo -n "OK"
57     else
58         (( tests_failed++ )) || true
59         echo -n "FAIL"
60     fi
61
62     # If we got an argument, append it after test result
63     if [ -n "$1" ]; then
64         echo " $1"
65     else
66         echo ""
67     fi
68 }
69
70 # Print report of all previous test results
71 TEST_REPORT()
72 {
73     echo ""
74     echo ""
75     echo "Test Report"
76     echo "==========="
77
78     if [ "$tests_failed" == "" ]; then
79         echo "All $tests_total tests passed."
80         echo ""
81         return 0
82     else
83         echo "$tests_failed of $tests_total tests failed."
84         echo ""
85         return 1
86     fi
87 }
88
89 # Does a string contain a regular expression pattern
90 #
91 # Example:
92 #
93 #    contains "All's well that ends well" "s.well"
94 contains()
95 {
96     grep -q "$2" <<< $1
97 }
98
99 # POST to a URL endpoint with optional JSON data
100 #
101 # Usage:
102 #
103 # curl_post <ENDPOINT> [data] [CURL_OPTIONS]
104 curl_post()
105 {
106     $CURL ${3:-} -X POST ${2:+-H 'Content-Type: application/json' -d "$2"} $URL/$1
107 }
108
109 # POST to a URL endpoint with optional JSON data using a cookie
110 #
111 # Usage:
112 #
113 # curl_post_cookie <name> <ENDPOINT> [data] [CURL_OPTIONS]
114 #
115 # Where <name> is a string for which there is a defined variable
116 # named ${name}_cookie which in turn holds a value that is a filename
117 # of a valid cookie
118 curl_post_cookie()
119 {
120     cookie=${1}_cookie
121     curl_post $2 "${3:-}" "-b ${!cookie} ${4:-}"
122 }
123
124 # PUT to a URL endpoint with optional JSON data
125 #
126 # Usage:
127 #
128 # curl_post <ENDPOINT> [data] [CURL_OPTIONS]
129 curl_put()
130 {
131     $CURL ${3:-} -X PUT ${2:+-H 'Content-Type: application/json' -d "$2"} $URL/$1
132 }
133
134 # GET from a URL endpoint
135 #
136 # Usage:
137 #
138 # curl_get <ENDPOINT> [CURL_OPTIONS]
139 curl_get()
140 {
141     $CURL ${2:-} $URL/$1
142 }
143
144 # GET from a URL endpoint using a cookie
145 #
146 # Usage:
147 #
148 # curl_get_cookie <name> <ENDPOINT> [CURL_OPTIONS]
149 #
150 # Where <name> is a string for which there is a defined variable
151 # named ${name}_cookie which in turn holds a value that is a filename
152 # of a valid cookie
153 curl_get_cookie()
154 {
155     cookie=${1}_cookie
156     curl_get $2 "-b ${!cookie} ${3:-}"
157 }
158
159 # Create a new game of the specified engine type
160 #
161 # Usage:
162 #
163 # new_game <ENGINE>
164 new_game()
165 {
166     curl_post new/$1 | jq -r .
167 }
168
169 TEST_SECTION "LMNO (super-site for games)"
170
171 TEST_SUBSECTION "Testing home page"
172 home_page=$($CURL $URL)
173
174 TEST "Contains 'Join Game'"
175 contains "$home_page" "Join Game"
176 TEST_END
177
178 TEST "Contains 'Host a new game'"
179 contains "$home_page" "Host a new game"
180 TEST_END
181
182 TEST_SUBSECTION "Creating some new games"
183
184 TEST "Empires"
185 empires_game_id=$(new_game empires)
186 test "$empires_game_id" != ""
187 TEST_END $empires_game_id
188
189 TEST "Tic Tac Toe"
190 tictactoe_game_id=$(new_game tictactoe)
191 test "$tictactoe_game_id" != ""
192 TEST_END $tictactoe_game_id
193
194 TEST_SUBSECTION "Test redirects"
195
196 TEST "Redirect of /GAMEID at top level"
197 redirect=$(curl_get $empires_game_id)
198 test "$redirect" = "Moved Permanently. Redirecting to /empires/$empires_game_id/"
199 TEST_END
200
201 TEST "Redirect of lowercase /gameid at top level"
202 empires_game_id_lower=$(tr '[:upper:]' '[:lower:]' <<< $empires_game_id)
203 redirect=$(curl_get $empires_game_id_lower)
204 test "$redirect" = "Moved Permanently. Redirecting to /$empires_game_id/"
205 TEST_END
206
207 TEST "Redirect of lowercase /empires/gameid"
208 redirect=$(curl_get empires/$empires_game_id_lower)
209 test "$redirect" = "Moved Permanently. Redirecting to /empires/$empires_game_id/"
210 TEST_END
211
212 TEST_SECTION "Empires game"
213
214 empires_game_path=empires/$empires_game_id
215
216 TEST_SUBSECTION "Empires game /register"
217
218 empires_register()
219 {
220     curl_post $empires_game_path/register "{\"name\": \"$1\", \"character\": \"$2\"}"
221 }
222
223 empires_players_string()
224 {
225     curl_get $empires_game_path/players | jq -r .[].name | tr '\n' ','
226 }
227
228 empires_characters_string()
229 {
230     curl_get $empires_game_path/characters | jq -r .[] | tr '\n' ','
231 }
232
233 TEST "Registering a player returns an ID"
234 carl_id=$(empires_register Carl "Bugs Bunny" | jq -r .)
235 test "$carl_id" = "1"
236 TEST_END
237
238 TEST "Registering several more players"
239 empires_register Richard "Bob Hope" > /dev/null
240 empires_register Kevin "Elvis Presley" > /dev/null
241 empires_register Stacy Phineas > /dev/null
242 empires_register David "Red Power Ranger" > /dev/null
243 empires_register Nancy "Audrey Hepburn" > /dev/null
244 bogus_id=$(empires_register Bogus "Mr. Bogus")
245 TEST_END
246
247 TEST 'Verify complete players list (with "Bogus")'
248 players=$(empires_players_string)
249 test "$players" = "Carl,Richard,Kevin,Stacy,David,Nancy,Bogus,"
250 TEST_END
251
252 TEST 'Verify complete players list (with "Mr. Bogus")'
253 characters=$(empires_characters_string)
254 test "$characters" = "Bugs Bunny,Bob Hope,Elvis Presley,Phineas,Red Power Ranger,Audrey Hepburn,Mr. Bogus,"
255 TEST_END
256
257 TEST_SUBSECTION "Empires game /deregister"
258
259 empires_deregister()
260 {
261     curl_post $empires_game_path/deregister/$1
262 }
263
264 TEST "Removing the bogus player"
265 empires_deregister $bogus_id
266 TEST_END
267
268 TEST 'Verify modified players list (w/o "Bogus")"'
269 players=$(empires_players_string)
270 test "$players" = "Carl,Richard,Kevin,Stacy,David,Nancy,"
271 TEST_END
272
273 TEST 'Verify modified characters list (w/o "Mr. Bogus")'
274 characters=$(empires_characters_string)
275 test "$characters" = "Bugs Bunny,Bob Hope,Elvis Presley,Phineas,Red Power Ranger,Audrey Hepburn,"
276 TEST_END
277
278 TEST_SUBSECTION "Empires game /capture"
279
280 empires_capture()
281 {
282     curl_post $empires_game_path/capture/$1/$2
283 }
284
285 empires_empires_string()
286 {
287     # Get empires as a compact string (much more compact than JSON)
288     curl_get $empires_game_path/empires | jq -c '.[] | [.id,.captures]' | tr '\n' ','
289 }
290
291 TEST "Verify empires before any captures"
292 empires=$(empires_empires_string)
293 test "$empires" = "[1,[]],[2,[]],[3,[]],[4,[]],[5,[]],[6,[]],"
294 TEST_END
295
296 TEST "Perform some captures"
297 empires_capture 1 2
298 empires_capture 3 5
299 empires_capture 4 6
300 empires_capture 3 4
301 TEST_END
302
303 TEST "Verify empires after captures"
304 empires=$(empires_empires_string)
305 test "$empires" = "[1,[2]],[2,[]],[3,[5,4]],[4,[6]],[5,[]],[6,[]],"
306 TEST_END
307
308 TEST_SUBSECTION "Empires game /liberate"
309
310 empires_liberate()
311 {
312     curl_post $empires_game_path/liberate/$1
313 }
314
315 TEST "Liberate a player"
316 empires_liberate 2
317 TEST_END
318
319 TEST "Verify empires after liberate"
320 empires=$(empires_empires_string)
321 test "$empires" = "[1,[]],[2,[]],[3,[5,4]],[4,[6]],[5,[]],[6,[]],"
322 TEST_END
323
324 TEST_SUBSECTION "Empires game /reset"
325
326 empires_reset()
327 {
328     curl_post $empires_game_path/reset
329 }
330
331 TEST "Reset the game"
332 empires_reset
333 TEST_END
334
335 TEST "Verify players is now empty"
336 players=$(empires_players_string)
337 test "$players" = ""
338 TEST_END
339
340 TEST_SECTION "Tic Tac Toe game"
341
342 tictactoe_game_path=tictactoe/$tictactoe_game_id
343
344 tictactoe_profile()
345 {
346     curl_put /profile "{ \"nickname\": \"$1\" }" "-c .cookie-tictactoe"
347 }
348
349 tictactoe_move()
350 {
351     curl_post $tictactoe_game_path/move "{ \"move\": $1 }" "-b .cookie-tictactoe"
352 }
353
354 tictactoe_player_info()
355 {
356     curl_get $tictactoe_game_path/events  "-m 0.1 -b .cookie-tictactoe" 2>&1 \
357         | grep player-info -A 1 \
358         | grep ^data
359 }
360
361 tictactoe_player_name()
362 {
363     curl_put $tictactoe_game_path/player "{ \"name\": \"$1\" }" "-b .cookie-tictactoe"
364 }
365
366 tictactoe_player_team()
367 {
368     curl_put $tictactoe_game_path/player "{ \"team\": \"$1\" }" "-b .cookie-tictactoe"
369 }
370
371 TEST_SUBSECTION "Tic Tac Toe player-info"
372
373 TEST "Hit LMNO /profile to set name to 'curl'"
374 tictactoe_profile curl
375 TEST_END
376
377 TEST "Verify player-info event reports 'curl' name"
378 result=$(tictactoe_player_info)
379 test "$result" = 'data: {"id":1,"active":true,"name":"curl","team":""}'
380 TEST_END
381
382 TEST_SUBSECTION "Tic Tac Toe /player"
383
384 TEST "Change name to 'newname'"
385 tictactoe_player_name newname
386 result=$(tictactoe_player_info)
387 test "$result" = 'data: {"id":1,"active":true,"name":"newname","team":""}'
388 TEST_END
389
390 TEST "Change team to 'X'"
391 tictactoe_player_team X
392 result=$(tictactoe_player_info)
393 test "$result" = 'data: {"id":1,"active":true,"name":"newname","team":"X"}'
394 TEST_END
395
396 TEST "Change team to 'O'"
397 tictactoe_player_team O
398 result=$(tictactoe_player_info)
399 test "$result" = 'data: {"id":1,"active":true,"name":"newname","team":"O"}'
400 TEST_END
401
402 TEST "Verify cannot change team to 'Z'"
403 tictactoe_player_team Z
404 result=$(tictactoe_player_info)
405 test "$result" = 'data: {"id":1,"active":true,"name":"newname","team":"O"}'
406 TEST_END
407
408 TEST "Leave current team"
409 tictactoe_player_team ""
410 result=$(tictactoe_player_info)
411 test "$result" = 'data: {"id":1,"active":true,"name":"newname","team":""}'
412 TEST_END
413
414 TEST_SUBSECTION "Tic Tac Toe /move"
415
416 TEST "First move doesn't require a team"
417 result=$(tictactoe_move 0)
418 test "$result" = '{"legal":true}'
419 TEST_END
420
421 TEST "Second move does require a team"
422 result=$(tictactoe_move 4)
423 test "$result" = '{"legal":false,"message":"It'"'"'s not your turn to move"}'
424 TEST_END
425
426 TEST "Illegal to move when it's not your turn"
427 tictactoe_player_team X
428 result=$(tictactoe_move 4)
429 test "$result" = '{"legal":false,"message":"It'"'"'s not your turn to move"}'
430 TEST_END
431
432 TEST "Legal move to center square"
433 tictactoe_player_team O
434 result=$(tictactoe_move 4)
435 test "$result" = '{"legal":true}'
436 TEST_END
437
438 TEST "Move to center square again is now illegal"
439 tictactoe_player_team X
440 result=$(tictactoe_move 4)
441 test "$result" = '{"legal":false,"message":"Square is already occupied"}'
442 TEST_END
443
444 TEST_SECTION "Scribe game"
445
446 TEST "Create Scribe game"
447 scribe_game_id=$(new_game scribe)
448 test "$scribe_game_id" != ""
449 TEST_END $scribe_game_id
450
451 scribe_game_path=scribe/$scribe_game_id
452
453 # Usage: scribe_profile <name>
454 scribe_profile()
455 {
456     curl_put /profile "{ \"nickname\": \"$1\" }" "-c .cookie-scribe"
457 }
458
459 # Pulls a single named event out of the scribe event stream
460 #
461 # Usage: scribe_get_event <event_name>
462 scribe_get_event()
463 {
464     curl_get $scribe_game_path/events "-m 0.1 -b .cookie-scribe" 2>&1 \
465         | grep "^event: $1" -A 1 \
466         | grep ^data: \
467         | sed -e 's,^data: *,,'
468 }
469
470 # Usage: scribe_player_name
471 scribe_get_player_name()
472 {
473     scribe_get_event player-info | jq -r .name
474 }
475
476 TEST_SUBSECTION "Scribe player-info"
477
478 TEST "Hit LMNO /profile to set name to 'test-suite'"
479 scribe_profile test-suite
480 TEST_END
481
482 TEST "Verify player-info event reports 'test-suite' name"
483 result=$(scribe_get_player_name)
484 test "$result" = "test-suite"
485 TEST_END
486
487 scribe_player_info()
488 {
489     scribe_get_event player-info
490 }
491
492 scribe_set_player_name()
493 {
494     curl_put $scribe_game_path/player "{ \"name\": \"$1\" }" "-b .cookie-scribe"
495 }
496
497 scribe_set_player_team()
498 {
499     curl_put $scribe_game_path/player "{ \"team\": \"$1\" }" "-b .cookie-scribe"
500 }
501
502 TEST_SUBSECTION "Scribe /player"
503
504 TEST "Change name to 'testy'"
505 scribe_set_player_name testy
506 result=$(scribe_player_info)
507 test "$result" = '{"id":1,"active":true,"name":"testy","team":""}'
508 TEST_END
509
510 TEST "Change team to '+'"
511 scribe_set_player_team +
512 result=$(scribe_player_info)
513 test "$result" = '{"id":1,"active":true,"name":"testy","team":"+"}'
514 TEST_END
515
516 TEST "Change team to 'o'"
517 scribe_set_player_team o
518 result=$(scribe_player_info)
519 test "$result" = '{"id":1,"active":true,"name":"testy","team":"o"}'
520 TEST_END
521
522 TEST "Verify cannot change team to 'X'"
523 scribe_set_player_team X
524 result=$(scribe_player_info)
525 test "$result" = '{"id":1,"active":true,"name":"testy","team":"o"}'
526 TEST_END
527
528 TEST "Leave current team"
529 scribe_set_player_team ""
530 result=$(scribe_player_info)
531 test "$result" = '{"id":1,"active":true,"name":"testy","team":""}'
532 TEST_END
533
534 scribe_move()
535 {
536     curl_post $scribe_game_path/move "{ \"move\": $1 }" "-b .cookie-scribe"
537 }
538
539 TEST_SUBSECTION "Scribe /move"
540
541 TEST "First move doesn't require a team"
542 result=$(scribe_move '[4,0]')
543 test "$result" = '{"legal":true}'
544 TEST_END
545
546 TEST "Second move does require a team"
547 result=$(scribe_move '[0,3]')
548 test "$result" = '{"legal":false,"message":"It'"'"'s not your turn to move"}'
549 TEST_END
550
551 TEST "Illegal to move when it's not your turn"
552 scribe_set_player_team +
553 result=$(scribe_move '[0,3]')
554 test "$result" = '{"legal":false,"message":"It'"'"'s not your turn to move"}'
555 TEST_END
556
557 TEST "Legal move to an empty square"
558 scribe_set_player_team o
559 result=$(scribe_move '[0,3]')
560 test "$result" = '{"legal":true}'
561 TEST_END
562
563 TEST "Move to same again is now illegal"
564 scribe_set_player_team +
565 result=$(scribe_move '[0,3]')
566 test "$result" = '{"legal":false,"message":"Square is already occupied"}'
567 TEST_END
568
569 TEST "Move must be in correct mini-grid by last move"
570 scribe_set_player_team +
571 result=$(scribe_move '[1,8]')
572 test "$result" = '{"legal":false,"message":"Move is inconsistent with your previous move"}'
573 TEST_END
574
575 TEST "Move in correct mini-grid is now legal"
576 result=$(scribe_move '[0,8]')
577 test "$result" = '{"legal":true}'
578 TEST_END
579
580 TEST "Several moves to fill up the mini-grid 0"
581 scribe_set_player_team o
582 scribe_move '[3,0]' >/dev/null
583 scribe_set_player_team +
584 scribe_move '[8,0]' >/dev/null
585 scribe_set_player_team o
586 scribe_move '[0,0]' >/dev/null
587 scribe_set_player_team +
588 scribe_move '[0,1]' >/dev/null
589 scribe_set_player_team o
590 scribe_move '[0,2]' >/dev/null
591 scribe_set_player_team +
592 scribe_move '[1,0]' >/dev/null
593 scribe_set_player_team o
594 scribe_move '[2,0]' >/dev/null
595 scribe_set_player_team +
596 scribe_move '[0,5]' >/dev/null
597 scribe_set_player_team o
598 scribe_move '[0,6]' >/dev/null
599 scribe_set_player_team +
600 scribe_move '[5,0]' >/dev/null
601 scribe_set_player_team o
602 scribe_move '[6,0]' >/dev/null
603 scribe_set_player_team +
604 scribe_move '[0,7]' >/dev/null
605 scribe_set_player_team o
606 scribe_move '[0,4]' >/dev/null
607 scribe_set_player_team +
608 result=$(scribe_move '[7,0]')
609 test "$result" = '{"legal":true}'
610 TEST_END
611
612 TEST "Full mini grid allows a free move"
613 scribe_set_player_team o
614 scribe_move '[4,1]' >/dev/null
615 scribe_set_player_team +
616 result=$(scribe_move '[1,1]')
617 test "$result" = '{"legal":true}'
618 TEST_END
619
620 TEST_SECTION "Empathy game"
621
622 TEST_SUBSECTION "Create a game and register 3 players"
623
624 TEST "Create the game"
625 empathy_game_id=$(new_game empathy)
626 test "$empathy_game_id" != ""
627 TEST_END $empathy_game_id
628
629 empathy_game_path=empathy/$empathy_game_id
630
631 # Usage: empathy_get <player_name> <endpoint> [curl_options]
632 empathy_get()
633 {
634     curl_get_cookie $1 $empathy_game_path/$2 "${3:-}"
635 }
636
637 # Usage: empathy_post <player_name> <endpoint> [data]
638 empathy_post()
639 {
640     curl_post_cookie $1 $empathy_game_path/$2 "${3:-}"
641 }
642
643 # Given a player name as $1 (eg. "empathy_player_activate alice") set both
644 # $1_cookie and $1_pid (that is $alice_cookie and $alice_pid) to
645 # a filename containing a cookie and the PID of a running event-streaming
646 # process.
647 empathy_player_activate()
648 {
649     player="$1"
650     player_cookie=${player}_cookie
651     player_pid=${player}_pid
652
653     eval ${player_cookie}=".cookie-empathy-$player"
654     curl_put /profile "{ \"nickname\": \"$player\" }" "-c ${!player_cookie}"
655     empathy_get $player events >/dev/null 2>&1 &
656     eval ${player_pid}=$!
657     empathy_players+=($player)
658 }
659
660 empathy_player_reactivate()
661 {
662     player="$1"
663     player_pid=${player}_pid
664
665     empathy_get $player events >/dev/null 2>&1 &
666     eval ${player_pid}=$!
667 }
668
669 # Usage: empathy_player_deactivate <player_name>
670 empathy_player_deactivate()
671 {
672     player="$1"
673     player_pid=${player}_pid
674     if [ "${!player_pid}" != "" ]; then
675         pkill -P ${!player_pid}
676     fi
677     eval ${player_pid}=""
678 }
679
680 empathy_deactivate_all()
681 {
682     for player in ${empathy_players[*]}; do
683         empathy_player_deactivate $player
684     done
685 }
686
687 # Pulls a single named event out of the empathy event stream
688 #
689 # Usage: empathy_get_event <player_name> <event_name>
690 empathy_get_event()
691 {
692     empathy_get $1 events "-m 0.1" 2>&1 \
693         | grep "^event: $2" -A 1 \
694         | grep ^data: \
695         | sed -e 's,^data: *,,'
696 }
697
698 # Usage: empathy_player_name <player_name>
699 empathy_player_name()
700 {
701     empathy_get_event $1 player-info | jq -r .name
702 }
703
704 TEST "Set 'alice' in session"
705 empathy_player_activate alice
706 test "$alice_cookie" = ".cookie-empathy-alice"
707 TEST_END
708
709 TEST "Register alice and verify name"
710 result=$(empathy_player_name alice)
711 test "$result" = "alice"
712 TEST_END
713
714 TEST "Register bob"
715 empathy_player_activate bob
716 result=$(empathy_player_name bob)
717 test "$result" = "bob"
718 TEST_END
719
720 TEST "Register charlie"
721 empathy_player_activate charlie
722 result=$(empathy_player_name charlie)
723 test "$result" = "charlie"
724 TEST_END
725
726 TEST_SUBSECTION "Category selection"
727
728 # Usage: empathy_submit_prompt <player_name> <count> <prompt_string>
729 empathy_submit_prompt()
730 {
731     empathy_post $1 prompts "{ \"items\": $2, \"prompt\": \"$3\"}"
732 }
733
734 TEST "Huge numbers are rejected"
735 result=$(empathy_submit_prompt alice 10000 "10,000 Maniacs")
736 test "$result" = '{"valid":false,"message":"Maximum number of items is 20"}'
737 TEST_END
738
739 TEST "Submit a category"
740 prompt_id=$(empathy_submit_prompt alice 4 "4 things on a beach" | jq .id)
741 test "$prompt_id" = "1"
742 TEST_END
743
744 # Usage: empathy_vote <player_name> <prompt_id>
745 empathy_vote()
746 {
747     empathy_post $1 vote/$2
748 }
749
750 TEST "Vote on this category"
751 empathy_vote alice $prompt_id
752 test "$?" = "0"
753 TEST_END
754
755 # Usage: empathy_start <player_name> <prompt_id>
756 empathy_start()
757 {
758     empathy_post $1 start/$2
759 }
760
761 TEST "Start the game with this category"
762 empathy_start alice $prompt_id
763 test "$?" = "0"
764 TEST_END
765
766 # Usage: empathy_answer <player_name> <prompt_id> <answers_string>
767 empathy_answer()
768 {
769     empathy_post $1 answer/$2 "{ \"answers\": [$3]}"
770 }
771
772 TEST_SUBSECTION "Submitting answers"
773
774 TEST "Submit from a non-player fails"
775 bogus_cookie=/dev/null
776 result=$(empathy_answer bogus $prompt_id '"Sun", "Sand", "Water", "People"')
777 test "$result" = '{"valid":false,"message":"Player not found"}'
778 TEST_END
779
780 TEST "Submit from alice succeeds"
781 result=$(empathy_answer alice $prompt_id '"sun", "sand", "water", "people"')
782 test "$result" = '{"valid":true}'
783 TEST_END
784
785 TEST "Submit from bob succeeds"
786 result=$(empathy_answer bob $prompt_id '"sand", "sands", "SunLight", "towels"')
787 test "$result" = '{"valid":true}'
788 TEST_END
789
790 # Usage: empathy_ambiguities <player_name>
791 empathy_ambiguities()
792 {
793     empathy_get_event $1 game-state | jq .ambiguities
794 }
795
796 TEST "Judging hasn't started with player unsubmitted"
797 result=$(echo $(empathy_ambiguities alice))
798 test "$result" = "null"
799 TEST_END
800
801 TEST "Submit from charlie succeeds"
802 result=$(empathy_answer charlie $prompt_id '"SunShine", "Grains of Sand", "wafer", "people"')
803 test "$result" = '{"valid":true}'
804 TEST_END
805
806 TEST_SUBSECTION "Transition from answering to judging (no voting needed)"
807
808 TEST "Judging already started"
809 result=$(echo $(empathy_ambiguities alice))
810 test "$result" != "null"
811 TEST_END
812
813 TEST_SUBSECTION "Judging answers"
814
815 # Usage: empathy_ambiguities_list <player_name>
816 empathy_ambiguities_list()
817 {
818     empathy_get_event $1 game-state | jq .ambiguities[]
819 }
820
821 TEST "Received all unique words"
822 # echo here is to strip newlines
823 result=$(echo $(empathy_ambiguities_list alice))
824 test "$result" = '"Grains of Sand" "people" "sand" "sands" "sun" "SunLight" "SunShine" "towels" "wafer" "water"'
825 TEST_END
826
827 # Usage: empathy_judged <player_name> <prompt_id> <word_groups_string>
828 empathy_judged()
829 {
830     empathy_post $1 judged/$2 "{ \"word_groups\": $3}"
831 }
832
833 TEST "Submit word groups from alice"
834 result=$(empathy_judged alice $prompt_id '[{"words":["sun","SunLight","SunShine"],"kudos":false},{"words":["sand","sands","Grains of Sand"],"kudos":false},{"words":["water","wafer"],"kudos":false}]')
835 test "$result" = '{"valid":true}'
836 TEST_END
837
838 TEST "Submit word groups from bob"
839 result=$(empathy_judged bob $prompt_id '[{"words":["sands","grains of sand"],"kudos":false},{"words":["water","wafer"],"kudos":false}]')
840 test "$result" = '{"valid":true}'
841 TEST_END
842
843 # Usage: empathy_scores <player_name>
844 empathy_scores()
845 {
846     empathy_get_event $1 game-state | jq .scores
847 }
848
849 TEST "Scoring hasn't started with player unsubmitted"
850 result=$(echo $(empathy_scores alice))
851 test "$result" = "null"
852 TEST_END
853
854 TEST "Submit word groups from charlie"
855 result=$(empathy_judged charlie $prompt_id '[{"words":["SunLight","SunShine"],"kudos":false},{"words":["sand","Grains of Sand"],"kudos":false}]')
856 test "$result" = '{"valid":true}'
857 TEST_END
858
859 TEST_SUBSECTION "Transition from judging to scoring (no voting needed)"
860
861 TEST "Scoring already started"
862 result=$(echo $(empathy_scores alice))
863 test "$result" != "null"
864 TEST_END
865
866 # Usage: empathy_scores_names_numbers <player_name>
867 empathy_scores_names_numbers()
868 {
869     empathy_get_event $1 game-state | jq '.scores.scores[]|.players[],.score'
870 }
871
872 TEST_SUBSECTION "Scoring"
873
874 TEST "Verify final scores as expected"
875 # echo here is to strip newlines
876 result=$(echo $(empathy_scores_names_numbers alice))
877 test "$result" = '"charlie" 9 "alice" 8 "bob" 6'
878 TEST_END
879
880 # Usage: empathy_words_submitted <player_name>
881 empathy_words_submitted()
882 {
883     empathy_get_event $1 game-state | jq '.scores.words[].word'
884 }
885
886 TEST "Verify final list of words submitted"
887 # echo here is to strip newlines
888 result=$(echo $(empathy_words_submitted alice))
889 test "$result" = '"Grains of Sand/sand/sands" "SunLight/SunShine" "wafer/water" "people" "sun" "towels"'
890 TEST_END
891
892 TEST_SUBSECTION "New game (using voting to advance phases)"
893
894 empathy_reset()
895 {
896     curl_post $empathy_game_path/reset
897 }
898
899 TEST "Any post to /reset resets the game"
900 empathy_reset
901 test "$?" = "0"
902 TEST_END
903
904 TEST "Verify scoring is over"
905 result=$(echo $(empathy_scores alice))
906 test "$result" = "null"
907 TEST_END
908
909 # Usage: empathy_answering <player_name> <prompt_id>
910 empathy_answering()
911 {
912     empathy_post $1 answering/$2
913 }
914
915 TEST "Start 4-player game, 3 submissions"
916 empathy_player_activate dale
917 result=$(empathy_player_name dale)
918 test "$result" = "dale"
919 prompt_id=$(empathy_submit_prompt alice 4 "3 little words" | jq .id)
920 empathy_start alice $prompt_id
921 empathy_answer alice   $prompt_id '"I",    "love", "you"' >/dev/null
922 empathy_answer bob     $prompt_id '"I",    "love", "food"' >/dev/null
923 empathy_answer charlie $prompt_id '"food", "is",   "good"' >/dev/null
924 result=$(empathy_answering dale $prompt_id)
925 test "$result" = '{"valid":true}'
926 TEST_END
927
928 TEST "Judging hasn't started with player unsubmitted"
929 result=$(echo $(empathy_ambiguities alice))
930 test "$result" = "null"
931 TEST_END
932
933 # Usage: empathy_end_answers <player_name> <prompt_id>
934 empathy_end_answers()
935 {
936     empathy_post $1 end-answers/$2
937 }
938
939 TEST "Minority of players vote to end answering"
940 empathy_end_answers alice $prompt_id
941 empathy_end_answers bob $prompt_id
942 test "$?" = "0"
943 TEST_END
944
945 TEST "Judging still hasn't started"
946 result=$(echo $(empathy_ambiguities alice))
947 test "$result" = "null"
948 TEST_END
949
950 TEST "Majority of players vote to end answering"
951 empathy_end_answers charlie $prompt_id
952 test "$?" = "0"
953 TEST_END
954
955 TEST "Judging has now started"
956 result=$(echo $(empathy_ambiguities alice))
957 test "$result" != "null"
958 TEST_END
959
960 # Usage: empathy_players_judging <player_name>
961 empathy_players_judging()
962 {
963     empathy_get_event $1 game-state | jq .players_judging[]
964 }
965
966 TEST "Verify active players listed as judging"
967 # echo here is to strip newlines
968 result=$(echo $(empathy_players_judging alice))
969 test "$result" = '"alice" "bob" "charlie"'
970 TEST_END
971
972 TEST "Submit word groups from majority"
973 empathy_judged alice $prompt_id '[]' >/dev/null
974 result=$(empathy_judged bob $prompt_id '[]')
975 test "$result" = '{"valid":true}'
976 TEST_END
977
978 TEST "Scoring hasn't started with player unsubmitted"
979 result=$(echo $(empathy_scores alice))
980 test "$result" = "null"
981 TEST_END
982
983 # Usage: empathy_end_judging <player_name> <prompt_id>
984 empathy_end_judging()
985 {
986     empathy_post $1 end-judging/$2
987 }
988
989 TEST "Minority of players vote to end judging"
990 empathy_end_judging alice $prompt_id
991 test "$?" = "0"
992 TEST_END
993
994 TEST "Scoring still hasn't started"
995 result=$(echo $(empathy_scores alice))
996 test "$result" = "null"
997 TEST_END
998
999 TEST "Majority of players vote to end judging"
1000 empathy_end_judging bob $prompt_id
1001 test "$?" = "0"
1002 TEST_END
1003
1004 TEST "Scoring has now started"
1005 result=$(echo $(empathy_scores alice))
1006 test "$result" != "null"
1007 TEST_END
1008
1009 TEST_SUBSECTION "New game (no voting needed when all answered players judge)"
1010
1011 TEST "Start 4-player game, 3 submissions"
1012 empathy_reset
1013 prompt_id=$(empathy_submit_prompt alice 4 "1 truth or dare" | jq .id)
1014 empathy_start alice $prompt_id
1015 empathy_answer alice   $prompt_id '"truth"' >/dev/null
1016 empathy_answer bob     $prompt_id '"truth"' >/dev/null
1017 empathy_answer charlie $prompt_id '"dare"' >/dev/null
1018 empathy_end_answers alice $prompt_id
1019 empathy_end_answers bob $prompt_id
1020 empathy_end_answers charlie $prompt_id
1021 test "$?" = "0"
1022 TEST_END
1023
1024 TEST "Submit word groups from 2 players"
1025 empathy_judged alice $prompt_id '[]' >/dev/null
1026 result=$(empathy_judged bob $prompt_id '[]')
1027 test "$result" = '{"valid":true}'
1028 TEST_END
1029
1030 TEST "Scoring hasn't started with player unsubmitted"
1031 result=$(echo $(empathy_scores alice))
1032 test "$result" = "null"
1033 TEST_END
1034
1035 TEST "Submit word groups from a non-answering player"
1036 result=$(empathy_judged dale $prompt_id '[]')
1037 test "$result" = '{"valid":true}'
1038 TEST_END
1039
1040 TEST "Scoring still hasn't started"
1041 result=$(echo $(empathy_scores alice))
1042 test "$result" = "null"
1043 TEST_END
1044
1045 TEST "Submit word groups from last answering player"
1046 result=$(empathy_judged charlie $prompt_id '[]')
1047 test "$result" = '{"valid":true}'
1048 TEST_END
1049
1050 TEST "Scoring has now started"
1051 result=$(echo $(empathy_scores alice))
1052 test "$result" != "null"
1053 TEST_END
1054
1055 TEST_SUBSECTION "Non players don't affect judging requirements"
1056
1057 TEST "Start 2-player game with 6 registered players"
1058 empathy_reset
1059 empathy_player_activate eric
1060 empathy_player_activate fred
1061 prompt_id=$(empathy_submit_prompt alice 4 "1 truth or dare" | jq .id)
1062 empathy_start alice $prompt_id
1063 empathy_answer alice $prompt_id '"truth"' >/dev/null
1064 empathy_answer bob   $prompt_id '"true"' >/dev/null
1065 empathy_end_answers alice $prompt_id
1066 empathy_end_answers bob $prompt_id
1067 test "$?" = "0"
1068 TEST_END
1069
1070 TEST "1 player votes for a match"
1071 empathy_judged alice $prompt_id '[{"words":["truth","true"],"kudos":false}]' >/dev/null
1072 result=$(empathy_judged bob $prompt_id '[]')
1073 test "$result" = '{"valid":true}'
1074 TEST_END
1075
1076 TEST "Verify the match passed the vote"
1077 # echo here is to strip newlines
1078 result=$(echo $(empathy_scores_names_numbers alice))
1079 test "$result" = '"alice" "bob" 2 "charlie" "dale" "eric" "fred" 0'
1080 TEST_END
1081
1082 echo ""
1083 echo "NOTE: Slow tests ahead!"
1084 echo "If you are impatient and somehow \"know\" you don't care about the"
1085 echo "tests below then you can interrupt the test suite with Control-C"
1086 echo "to get a summary report on the tests that have already been run."
1087
1088 TEST_SUBSECTION "Inactive players don't appear in scores"
1089
1090 TEST "Start 2-player game with 6 registered players"
1091 empathy_reset
1092 prompt_id=$(empathy_submit_prompt alice 4 "1 best pet" | jq .id)
1093 empathy_start alice $prompt_id
1094 empathy_answer alice $prompt_id '"cats"' >/dev/null
1095 empathy_answer bob   $prompt_id '"dogs"' >/dev/null
1096 empathy_end_answers alice $prompt_id
1097 empathy_end_answers bob $prompt_id
1098 test "$?" = "0"
1099 TEST_END
1100
1101 TEST "Deactivate 3 players"
1102 empathy_player_deactivate dale
1103 empathy_player_deactivate eric
1104 empathy_player_deactivate fred
1105 sleep 30
1106 test "$?" = "0"
1107 TEST_END
1108
1109 TEST "Finish game with 2 active players"
1110 empathy_judged alice $prompt_id '[]' >/dev/null
1111 result=$(empathy_judged bob $prompt_id '[]')
1112 test "$result" = '{"valid":true}'
1113 TEST_END
1114
1115 TEST "Verify scores don't include inactive players"
1116 # echo here is to strip newlines
1117 result=$(echo $(empathy_scores_names_numbers alice))
1118 test "$result" = '"alice" "bob" 1 "charlie" 0'
1119 TEST_END
1120
1121 TEST_SUBSECTION "Deactivated players don't block future game phase advances"
1122
1123 TEST "New 3-player game, 2 submit right away"
1124 empathy_reset
1125 prompt_id=$(empathy_submit_prompt charlie 4 "2 legit 2 quit" | jq .id)
1126 empathy_start alice $prompt_id
1127 empathy_answer alice $prompt_id '"what", "gives?"' >/dev/null
1128 empathy_answer bob   $prompt_id '"so", "confused"' >/dev/null
1129 test "$?" = "0"
1130 TEST_END
1131
1132 TEST "Judging hasn't started with player unsubmitted"
1133 result=$(echo $(empathy_ambiguities alice))
1134 test "$result" = "null"
1135 TEST_END
1136
1137 TEST "Final active player submits"
1138 result=$(empathy_answer charlie $prompt_id '"best", "category"')
1139 test "$result" = '{"valid":true}'
1140 TEST_END
1141
1142 TEST "Judging has started (don't need inactive players)"
1143 result=$(echo $(empathy_ambiguities alice))
1144 test "$result" != "null"
1145 TEST_END
1146
1147 TEST "Submit word groups from 2 players"
1148 empathy_judged alice $prompt_id '[]' >/dev/null
1149 result=$(empathy_judged bob $prompt_id '[]')
1150 test "$result" = '{"valid":true}'
1151 TEST_END
1152
1153 TEST "Scoring hasn't started with player unsubmitted"
1154 result=$(echo $(empathy_scores alice))
1155 test "$result" = "null"
1156 TEST_END
1157
1158 TEST "Submit word groups from last answering player"
1159 result=$(empathy_judged charlie $prompt_id '[]')
1160 test "$result" = '{"valid":true}'
1161 TEST_END
1162
1163 TEST "Scoring has now started"
1164 result=$(echo $(empathy_scores alice))
1165 test "$result" != "null"
1166 TEST_END
1167
1168 TEST_SUBSECTION "Reactivated player is fully active"
1169
1170 TEST "The dale player is currently deactivated"
1171 test "$dale_pid" = ""
1172 TEST_END
1173
1174 TEST "Reactivate dale"
1175 empathy_player_reactivate dale
1176 test "$dale_pid" != ""
1177 TEST_END
1178
1179 TEST "New 4-player game, 3 submit right away"
1180 empathy_reset
1181 prompt_id=$(empathy_submit_prompt alice 1 "favorite letter" | jq .id)
1182 empathy_start alice $prompt_id
1183 empathy_answer alice   $prompt_id '"A"' >/dev/null
1184 empathy_answer bob     $prompt_id '"B"' >/dev/null
1185 empathy_answer charlie $prompt_id '"C"' >/dev/null
1186 test "$?" = "0"
1187 TEST_END
1188
1189 TEST "Judging hasn't started with player unsubmitted"
1190 result=$(echo $(empathy_ambiguities alice))
1191 test "$result" = "null"
1192 TEST_END
1193
1194 TEST "Final active player submits"
1195 result=$(empathy_answer dale $prompt_id '"D"')
1196 test "$result" = '{"valid":true}'
1197 TEST_END
1198
1199 TEST "Judging has started now"
1200 result=$(echo $(empathy_ambiguities alice))
1201 test "$result" != "null"
1202 TEST_END
1203
1204 cleanup_and_report